<?php namespace Myriad\NotifyClient\Client;

class Config {

  /**
   * The list of channels supported by the application.
   * @var mixed
   */
  private $channels;

  /**
   * The list of subscriptions supported by the application.
   * @var mixed
   */
  private $subscriptions;

  /**
   * When true, before the request is made, the requested channels and subscriptions are
   * checked against the lists configured for the client (by default, the values in
   * config/notification.php are used). If a requested channel or subscription is not found,
   * an exception will be thrown.
   * @var bool
   */
  private $shouldVerify;

  function __construct($args = null) {
    $this->channels = array_get($args, 'channels', config('notifications.channels'));
    $this->subscriptions = array_get($args, 'subscriptions', config('notifications.subscriptions'));
    $this->shouldVerify = array_get($args, 'shouldVerify', true);
  }

  /**
   * @return array
   */
  public function getChannels() {
    return $this->channels;
  }

  /**
   * @return array
   */
  public function getSubscriptions() {
    return $this->subscriptions;
  }

  /**
   * @return bool
   */
  public function shouldVerify(): bool {
    return $this->shouldVerify;
  }
}