<?php namespace Myriad\NotifyClient\Client;

use InvalidArgumentException;

trait ValidatesAgainstConfig {

  /**
   * @var Config
   */
  private $config;

  public function maybeAssertChannelsAreValid(array $channels) {
    if ($this->config->shouldVerify()) {
      if ($invalid = array_diff($channels, $this->config->getChannels())) {
        throw new InvalidArgumentException("Invalid channels specified: " . implode(',', $invalid));
      }
    }
  }

  public function maybeAssertSubscriptionsAreValid(array $subscriptions) {
    if ($this->config->shouldVerify()) {
      if ($invalid = array_diff($subscriptions, $this->config->getSubscriptions())) {
        throw new InvalidArgumentException("Invalid subscriptions specified: " . implode(',', $invalid));
      }
    }
  }
}