<?php namespace Myriad\NotifyClient\Utilities;

use Illuminate\Support\Collection;

trait HydratesModels {

  abstract protected function getItemClass();

  protected function getCollectionClass() {
    return Collection::class;
  }

  public function hydrateItem($data) {
    $class = $this->getItemClass();
    $item = new $class();
    $item->hydrate($data);
    return $item;
  }

  public function hydrateCollection ($data) {
    $class = $this->getCollectionClass();
    return (new $class($data))->map([$this, 'hydrateItem']);
  }
}